# Interface InputBuffer

All Known Subinterfaces:
  `InputFilter`

All Known Implementing Classes:
  `AjpProcessor.SocketInputBuffer, BufferedInputFilter, ChunkedInputFilter, Http11InputBuffer, IdentityInputFilter, SavedRequestInputFilter, VoidInputFilter`

public interface InputBuffer
This class is only for internal use in the protocol implementation. All reading from Tomcat (or adapter) should be done using Request.doRead().

## Method Summary

Modifier and Type
Method
Description
`int`
`available()`
Obtain an estimate of the number of bytes that can be read without blocking.
`int`
`doRead(ApplicationBufferHandler handler)`
Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler.

## Method Details

### doRead

int doRead(ApplicationBufferHandler handler) throws IOException
Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler. IMPORTANT: the current model assumes that the protocol will 'own' the ByteBuffer and return a pointer to it.

Parameters:
  `handler` - ApplicationBufferHandler that provides the buffer to read data into.
Returns:
  The number of bytes that have been added to the buffer or -1 for end of stream
Throws:
  `IOException` - If an I/O error occurs reading from the input stream

### available

int available()
Obtain an estimate of the number of bytes that can be read without blocking. Typically, this will be the number of available bytes known to be buffered.

Returns:
  The number of bytes that can be read without blocking